/* dasstyle.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dasstyle.h"

void *dasstyleStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dasstyleEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dasstyleDasstyleSave(struct dasstyleDasstyle *obj, int indent, FILE *f)
/* Save dasstyleDasstyle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASSTYLE>");
fprintf(f, "\n");
dasstyleStylesheetSave(obj->dasstyleStylesheet, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASSTYLE>\n");
}

struct dasstyleDasstyle *dasstyleDasstyleLoad(char *fileName)
/* Load dasstyleDasstyle from file. */
{
struct dasstyleDasstyle *obj;
xapParseAny(fileName, "DASSTYLE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleStylesheetSave(struct dasstyleStylesheet *obj, int indent, FILE *f)
/* Save dasstyleStylesheet to file. */
{
struct dasstyleCategory *dasstyleCategory;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STYLESHEET");
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "\n");
for (dasstyleCategory = obj->dasstyleCategory; dasstyleCategory != NULL; dasstyleCategory = dasstyleCategory->next)
   dasstyleCategorySave(dasstyleCategory, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</STYLESHEET>\n");
}

struct dasstyleStylesheet *dasstyleStylesheetLoad(char *fileName)
/* Load dasstyleStylesheet from file. */
{
struct dasstyleStylesheet *obj;
xapParseAny(fileName, "STYLESHEET", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleCategorySave(struct dasstyleCategory *obj, int indent, FILE *f)
/* Save dasstyleCategory to file. */
{
struct dasstyleType *dasstyleType;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CATEGORY");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
for (dasstyleType = obj->dasstyleType; dasstyleType != NULL; dasstyleType = dasstyleType->next)
   dasstyleTypeSave(dasstyleType, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CATEGORY>\n");
}

struct dasstyleCategory *dasstyleCategoryLoad(char *fileName)
/* Load dasstyleCategory from file. */
{
struct dasstyleCategory *obj;
xapParseAny(fileName, "CATEGORY", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleTypeSave(struct dasstyleType *obj, int indent, FILE *f)
/* Save dasstyleType to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TYPE");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
dasstyleGlyphSave(obj->dasstyleGlyph, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TYPE>\n");
}

struct dasstyleType *dasstyleTypeLoad(char *fileName)
/* Load dasstyleType from file. */
{
struct dasstyleType *obj;
xapParseAny(fileName, "TYPE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleGlyphSave(struct dasstyleGlyph *obj, int indent, FILE *f)
/* Save dasstyleGlyph to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<GLYPH>");
fprintf(f, "\n");
dasstyleBoxSave(obj->dasstyleBox, indent+2, f);
dasstyleToomanySave(obj->dasstyleToomany, indent+2, f);
dasstyleArrowSave(obj->dasstyleArrow, indent+2, f);
dasstyleLineSave(obj->dasstyleLine, indent+2, f);
dasstyleConnectorSave(obj->dasstyleConnector, indent+2, f);
dasstyleTextSave(obj->dasstyleText, indent+2, f);
dasstyleExSave(obj->dasstyleEx, indent+2, f);
dasstyleCrossSave(obj->dasstyleCross, indent+2, f);
dasstyleDotSave(obj->dasstyleDot, indent+2, f);
dasstyleTriangleSave(obj->dasstyleTriangle, indent+2, f);
dasstyleSpanSave(obj->dasstyleSpan, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</GLYPH>\n");
}

struct dasstyleGlyph *dasstyleGlyphLoad(char *fileName)
/* Load dasstyleGlyph from file. */
{
struct dasstyleGlyph *obj;
xapParseAny(fileName, "GLYPH", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleBoxSave(struct dasstyleBox *obj, int indent, FILE *f)
/* Save dasstyleBox to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<BOX>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
dasstyleOutlinecolorSave(obj->dasstyleOutlinecolor, indent+2, f);
dasstyleLinewidthSave(obj->dasstyleLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</BOX>\n");
}

struct dasstyleBox *dasstyleBoxLoad(char *fileName)
/* Load dasstyleBox from file. */
{
struct dasstyleBox *obj;
xapParseAny(fileName, "BOX", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleToomanySave(struct dasstyleToomany *obj, int indent, FILE *f)
/* Save dasstyleToomany to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TOOMANY>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
dasstyleOutlinecolorSave(obj->dasstyleOutlinecolor, indent+2, f);
dasstyleLinewidthSave(obj->dasstyleLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TOOMANY>\n");
}

struct dasstyleToomany *dasstyleToomanyLoad(char *fileName)
/* Load dasstyleToomany from file. */
{
struct dasstyleToomany *obj;
xapParseAny(fileName, "TOOMANY", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleArrowSave(struct dasstyleArrow *obj, int indent, FILE *f)
/* Save dasstyleArrow to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<ARROW>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
dasstyleParallelSave(obj->dasstyleParallel, indent+2, f);
dasstyleNortheastSave(obj->dasstyleNortheast, indent+2, f);
dasstyleSouthwestSave(obj->dasstyleSouthwest, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</ARROW>\n");
}

struct dasstyleArrow *dasstyleArrowLoad(char *fileName)
/* Load dasstyleArrow from file. */
{
struct dasstyleArrow *obj;
xapParseAny(fileName, "ARROW", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleLineSave(struct dasstyleLine *obj, int indent, FILE *f)
/* Save dasstyleLine to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<LINE>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</LINE>\n");
}

struct dasstyleLine *dasstyleLineLoad(char *fileName)
/* Load dasstyleLine from file. */
{
struct dasstyleLine *obj;
xapParseAny(fileName, "LINE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleConnectorSave(struct dasstyleConnector *obj, int indent, FILE *f)
/* Save dasstyleConnector to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CONNECTOR>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CONNECTOR>\n");
}

struct dasstyleConnector *dasstyleConnectorLoad(char *fileName)
/* Load dasstyleConnector from file. */
{
struct dasstyleConnector *obj;
xapParseAny(fileName, "CONNECTOR", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleTextSave(struct dasstyleText *obj, int indent, FILE *f)
/* Save dasstyleText to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TEXT>");
fprintf(f, "\n");
dasstyleFontSave(obj->dasstyleFont, indent+2, f);
dasstyleFontsizeSave(obj->dasstyleFontsize, indent+2, f);
dasstyleStringSave(obj->dasstyleString, indent+2, f);
dasstyleStyleSave(obj->dasstyleStyle, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TEXT>\n");
}

struct dasstyleText *dasstyleTextLoad(char *fileName)
/* Load dasstyleText from file. */
{
struct dasstyleText *obj;
xapParseAny(fileName, "TEXT", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleExSave(struct dasstyleEx *obj, int indent, FILE *f)
/* Save dasstyleEx to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<EX>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</EX>\n");
}

struct dasstyleEx *dasstyleExLoad(char *fileName)
/* Load dasstyleEx from file. */
{
struct dasstyleEx *obj;
xapParseAny(fileName, "EX", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleCrossSave(struct dasstyleCross *obj, int indent, FILE *f)
/* Save dasstyleCross to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CROSS>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CROSS>\n");
}

struct dasstyleCross *dasstyleCrossLoad(char *fileName)
/* Load dasstyleCross from file. */
{
struct dasstyleCross *obj;
xapParseAny(fileName, "CROSS", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleDotSave(struct dasstyleDot *obj, int indent, FILE *f)
/* Save dasstyleDot to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DOT>");
fprintf(f, "\n");
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DOT>\n");
}

struct dasstyleDot *dasstyleDotLoad(char *fileName)
/* Load dasstyleDot from file. */
{
struct dasstyleDot *obj;
xapParseAny(fileName, "DOT", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleTriangleSave(struct dasstyleTriangle *obj, int indent, FILE *f)
/* Save dasstyleTriangle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TRIANGLE>");
fprintf(f, "\n");
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
dasstyleOutlinecolorSave(obj->dasstyleOutlinecolor, indent+2, f);
dasstyleLinewidthSave(obj->dasstyleLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TRIANGLE>\n");
}

struct dasstyleTriangle *dasstyleTriangleLoad(char *fileName)
/* Load dasstyleTriangle from file. */
{
struct dasstyleTriangle *obj;
xapParseAny(fileName, "TRIANGLE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleSpanSave(struct dasstyleSpan *obj, int indent, FILE *f)
/* Save dasstyleSpan to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SPAN>");
fprintf(f, "\n");
dasstyleColorSave(obj->dasstyleColor, indent+2, f);
dasstyleWidthSave(obj->dasstyleWidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SPAN>\n");
}

struct dasstyleSpan *dasstyleSpanLoad(char *fileName)
/* Load dasstyleSpan from file. */
{
struct dasstyleSpan *obj;
xapParseAny(fileName, "SPAN", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleWidthSave(struct dasstyleWidth *obj, int indent, FILE *f)
/* Save dasstyleWidth to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<WIDTH>");
fprintf(f, "%s", obj->text);
fprintf(f, "</WIDTH>\n");
}

struct dasstyleWidth *dasstyleWidthLoad(char *fileName)
/* Load dasstyleWidth from file. */
{
struct dasstyleWidth *obj;
xapParseAny(fileName, "WIDTH", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleColorSave(struct dasstyleColor *obj, int indent, FILE *f)
/* Save dasstyleColor to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<COLOR>");
fprintf(f, "%s", obj->text);
fprintf(f, "</COLOR>\n");
}

struct dasstyleColor *dasstyleColorLoad(char *fileName)
/* Load dasstyleColor from file. */
{
struct dasstyleColor *obj;
xapParseAny(fileName, "COLOR", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleOutlinecolorSave(struct dasstyleOutlinecolor *obj, int indent, FILE *f)
/* Save dasstyleOutlinecolor to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<OUTLINECOLOR>");
fprintf(f, "%s", obj->text);
fprintf(f, "</OUTLINECOLOR>\n");
}

struct dasstyleOutlinecolor *dasstyleOutlinecolorLoad(char *fileName)
/* Load dasstyleOutlinecolor from file. */
{
struct dasstyleOutlinecolor *obj;
xapParseAny(fileName, "OUTLINECOLOR", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleLinewidthSave(struct dasstyleLinewidth *obj, int indent, FILE *f)
/* Save dasstyleLinewidth to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<LINEWIDTH>");
fprintf(f, "%s", obj->text);
fprintf(f, "</LINEWIDTH>\n");
}

struct dasstyleLinewidth *dasstyleLinewidthLoad(char *fileName)
/* Load dasstyleLinewidth from file. */
{
struct dasstyleLinewidth *obj;
xapParseAny(fileName, "LINEWIDTH", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleParallelSave(struct dasstyleParallel *obj, int indent, FILE *f)
/* Save dasstyleParallel to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<PARALLEL>");
fprintf(f, "%s", obj->text);
fprintf(f, "</PARALLEL>\n");
}

struct dasstyleParallel *dasstyleParallelLoad(char *fileName)
/* Load dasstyleParallel from file. */
{
struct dasstyleParallel *obj;
xapParseAny(fileName, "PARALLEL", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleNortheastSave(struct dasstyleNortheast *obj, int indent, FILE *f)
/* Save dasstyleNortheast to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<NORTHEAST>");
fprintf(f, "%s", obj->text);
fprintf(f, "</NORTHEAST>\n");
}

struct dasstyleNortheast *dasstyleNortheastLoad(char *fileName)
/* Load dasstyleNortheast from file. */
{
struct dasstyleNortheast *obj;
xapParseAny(fileName, "NORTHEAST", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleSouthwestSave(struct dasstyleSouthwest *obj, int indent, FILE *f)
/* Save dasstyleSouthwest to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOUTHWEST>");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOUTHWEST>\n");
}

struct dasstyleSouthwest *dasstyleSouthwestLoad(char *fileName)
/* Load dasstyleSouthwest from file. */
{
struct dasstyleSouthwest *obj;
xapParseAny(fileName, "SOUTHWEST", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleFontSave(struct dasstyleFont *obj, int indent, FILE *f)
/* Save dasstyleFont to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<FONT>");
fprintf(f, "%s", obj->text);
fprintf(f, "</FONT>\n");
}

struct dasstyleFont *dasstyleFontLoad(char *fileName)
/* Load dasstyleFont from file. */
{
struct dasstyleFont *obj;
xapParseAny(fileName, "FONT", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleFontsizeSave(struct dasstyleFontsize *obj, int indent, FILE *f)
/* Save dasstyleFontsize to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<FONTSIZE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</FONTSIZE>\n");
}

struct dasstyleFontsize *dasstyleFontsizeLoad(char *fileName)
/* Load dasstyleFontsize from file. */
{
struct dasstyleFontsize *obj;
xapParseAny(fileName, "FONTSIZE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleStringSave(struct dasstyleString *obj, int indent, FILE *f)
/* Save dasstyleString to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STRING>");
fprintf(f, "%s", obj->text);
fprintf(f, "</STRING>\n");
}

struct dasstyleString *dasstyleStringLoad(char *fileName)
/* Load dasstyleString from file. */
{
struct dasstyleString *obj;
xapParseAny(fileName, "STRING", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void dasstyleStyleSave(struct dasstyleStyle *obj, int indent, FILE *f)
/* Save dasstyleStyle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STYLE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</STYLE>\n");
}

struct dasstyleStyle *dasstyleStyleLoad(char *fileName)
/* Load dasstyleStyle from file. */
{
struct dasstyleStyle *obj;
xapParseAny(fileName, "STYLE", dasstyleStartHandler, dasstyleEndHandler, NULL, &obj);
return obj;
}

void *dasstyleStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASSTYLE"))
    {
    struct dasstyleDasstyle *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "STYLESHEET"))
    {
    struct dasstyleStylesheet *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASSTYLE"))
            {
            struct dasstyleDasstyle *parent = st->object;
            slAddHead(&parent->dasstyleStylesheet, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "CATEGORY"))
    {
    struct dasstyleCategory *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "STYLESHEET"))
            {
            struct dasstyleStylesheet *parent = st->object;
            slAddHead(&parent->dasstyleCategory, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "TYPE"))
    {
    struct dasstyleType *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "CATEGORY"))
            {
            struct dasstyleCategory *parent = st->object;
            slAddHead(&parent->dasstyleType, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "GLYPH"))
    {
    struct dasstyleGlyph *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TYPE"))
            {
            struct dasstyleType *parent = st->object;
            slAddHead(&parent->dasstyleGlyph, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "BOX"))
    {
    struct dasstyleBox *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleBox, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "TOOMANY"))
    {
    struct dasstyleToomany *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleToomany, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "ARROW"))
    {
    struct dasstyleArrow *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleArrow, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "LINE"))
    {
    struct dasstyleLine *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleLine, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "CONNECTOR"))
    {
    struct dasstyleConnector *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleConnector, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "TEXT"))
    {
    struct dasstyleText *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleText, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "EX"))
    {
    struct dasstyleEx *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleEx, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "CROSS"))
    {
    struct dasstyleCross *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleCross, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "DOT"))
    {
    struct dasstyleDot *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleDot, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "TRIANGLE"))
    {
    struct dasstyleTriangle *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleTriangle, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SPAN"))
    {
    struct dasstyleSpan *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dasstyleGlyph *parent = st->object;
            slAddHead(&parent->dasstyleSpan, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "WIDTH"))
    {
    struct dasstyleWidth *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dasstyleBox *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dasstyleToomany *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "ARROW"))
            {
            struct dasstyleArrow *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "LINE"))
            {
            struct dasstyleLine *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "CONNECTOR"))
            {
            struct dasstyleConnector *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "EX"))
            {
            struct dasstyleEx *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "CROSS"))
            {
            struct dasstyleCross *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "DOT"))
            {
            struct dasstyleDot *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dasstyleTriangle *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        else if (sameString(st->elName, "SPAN"))
            {
            struct dasstyleSpan *parent = st->object;
            slAddHead(&parent->dasstyleWidth, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "COLOR"))
    {
    struct dasstyleColor *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dasstyleBox *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dasstyleToomany *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "ARROW"))
            {
            struct dasstyleArrow *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "LINE"))
            {
            struct dasstyleLine *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "CONNECTOR"))
            {
            struct dasstyleConnector *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "TEXT"))
            {
            struct dasstyleText *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "EX"))
            {
            struct dasstyleEx *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "CROSS"))
            {
            struct dasstyleCross *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "DOT"))
            {
            struct dasstyleDot *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dasstyleTriangle *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        else if (sameString(st->elName, "SPAN"))
            {
            struct dasstyleSpan *parent = st->object;
            slAddHead(&parent->dasstyleColor, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "OUTLINECOLOR"))
    {
    struct dasstyleOutlinecolor *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dasstyleBox *parent = st->object;
            slAddHead(&parent->dasstyleOutlinecolor, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dasstyleToomany *parent = st->object;
            slAddHead(&parent->dasstyleOutlinecolor, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dasstyleTriangle *parent = st->object;
            slAddHead(&parent->dasstyleOutlinecolor, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "LINEWIDTH"))
    {
    struct dasstyleLinewidth *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dasstyleBox *parent = st->object;
            slAddHead(&parent->dasstyleLinewidth, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dasstyleToomany *parent = st->object;
            slAddHead(&parent->dasstyleLinewidth, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dasstyleTriangle *parent = st->object;
            slAddHead(&parent->dasstyleLinewidth, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "PARALLEL"))
    {
    struct dasstyleParallel *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dasstyleArrow *parent = st->object;
            slAddHead(&parent->dasstyleParallel, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "NORTHEAST"))
    {
    struct dasstyleNortheast *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dasstyleArrow *parent = st->object;
            slAddHead(&parent->dasstyleNortheast, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SOUTHWEST"))
    {
    struct dasstyleSouthwest *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dasstyleArrow *parent = st->object;
            slAddHead(&parent->dasstyleSouthwest, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "FONT"))
    {
    struct dasstyleFont *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dasstyleText *parent = st->object;
            slAddHead(&parent->dasstyleFont, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "FONTSIZE"))
    {
    struct dasstyleFontsize *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dasstyleText *parent = st->object;
            slAddHead(&parent->dasstyleFontsize, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "STRING"))
    {
    struct dasstyleString *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dasstyleText *parent = st->object;
            slAddHead(&parent->dasstyleString, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "STYLE"))
    {
    struct dasstyleStyle *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dasstyleText *parent = st->object;
            slAddHead(&parent->dasstyleStyle, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dasstyleEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASSTYLE"))
    {
    struct dasstyleDasstyle *obj = stack->object;
    if (obj->dasstyleStylesheet == NULL)
        xapError(xp, "Missing STYLESHEET");
    if (obj->dasstyleStylesheet->next != NULL)
        xapError(xp, "Multiple STYLESHEET");
    }
else if (sameString(name, "STYLESHEET"))
    {
    struct dasstyleStylesheet *obj = stack->object;
    if (obj->dasstyleCategory == NULL)
        xapError(xp, "Missing CATEGORY");
    slReverse(&obj->dasstyleCategory);
    }
else if (sameString(name, "CATEGORY"))
    {
    struct dasstyleCategory *obj = stack->object;
    if (obj->dasstyleType == NULL)
        xapError(xp, "Missing TYPE");
    slReverse(&obj->dasstyleType);
    }
else if (sameString(name, "TYPE"))
    {
    struct dasstyleType *obj = stack->object;
    if (obj->dasstyleGlyph == NULL)
        xapError(xp, "Missing GLYPH");
    if (obj->dasstyleGlyph->next != NULL)
        xapError(xp, "Multiple GLYPH");
    }
else if (sameString(name, "GLYPH"))
    {
    struct dasstyleGlyph *obj = stack->object;
    if (obj->dasstyleBox != NULL && obj->dasstyleBox->next != NULL)
        xapError(xp, "Multiple BOX");
    if (obj->dasstyleToomany != NULL && obj->dasstyleToomany->next != NULL)
        xapError(xp, "Multiple TOOMANY");
    if (obj->dasstyleArrow != NULL && obj->dasstyleArrow->next != NULL)
        xapError(xp, "Multiple ARROW");
    if (obj->dasstyleLine != NULL && obj->dasstyleLine->next != NULL)
        xapError(xp, "Multiple LINE");
    if (obj->dasstyleConnector != NULL && obj->dasstyleConnector->next != NULL)
        xapError(xp, "Multiple CONNECTOR");
    if (obj->dasstyleText != NULL && obj->dasstyleText->next != NULL)
        xapError(xp, "Multiple TEXT");
    if (obj->dasstyleEx != NULL && obj->dasstyleEx->next != NULL)
        xapError(xp, "Multiple EX");
    if (obj->dasstyleCross != NULL && obj->dasstyleCross->next != NULL)
        xapError(xp, "Multiple CROSS");
    if (obj->dasstyleDot != NULL && obj->dasstyleDot->next != NULL)
        xapError(xp, "Multiple DOT");
    if (obj->dasstyleTriangle != NULL && obj->dasstyleTriangle->next != NULL)
        xapError(xp, "Multiple TRIANGLE");
    if (obj->dasstyleSpan != NULL && obj->dasstyleSpan->next != NULL)
        xapError(xp, "Multiple SPAN");
    }
else if (sameString(name, "BOX"))
    {
    struct dasstyleBox *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dasstyleOutlinecolor != NULL && obj->dasstyleOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dasstyleLinewidth != NULL && obj->dasstyleLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "TOOMANY"))
    {
    struct dasstyleToomany *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dasstyleOutlinecolor != NULL && obj->dasstyleOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dasstyleLinewidth != NULL && obj->dasstyleLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "ARROW"))
    {
    struct dasstyleArrow *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dasstyleParallel != NULL && obj->dasstyleParallel->next != NULL)
        xapError(xp, "Multiple PARALLEL");
    if (obj->dasstyleNortheast != NULL && obj->dasstyleNortheast->next != NULL)
        xapError(xp, "Multiple NORTHEAST");
    if (obj->dasstyleSouthwest != NULL && obj->dasstyleSouthwest->next != NULL)
        xapError(xp, "Multiple SOUTHWEST");
    }
else if (sameString(name, "LINE"))
    {
    struct dasstyleLine *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "CONNECTOR"))
    {
    struct dasstyleConnector *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "TEXT"))
    {
    struct dasstyleText *obj = stack->object;
    if (obj->dasstyleFont != NULL && obj->dasstyleFont->next != NULL)
        xapError(xp, "Multiple FONT");
    if (obj->dasstyleFontsize != NULL && obj->dasstyleFontsize->next != NULL)
        xapError(xp, "Multiple FONTSIZE");
    if (obj->dasstyleString != NULL && obj->dasstyleString->next != NULL)
        xapError(xp, "Multiple STRING");
    if (obj->dasstyleStyle != NULL && obj->dasstyleStyle->next != NULL)
        xapError(xp, "Multiple STYLE");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "EX"))
    {
    struct dasstyleEx *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "CROSS"))
    {
    struct dasstyleCross *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "DOT"))
    {
    struct dasstyleDot *obj = stack->object;
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "TRIANGLE"))
    {
    struct dasstyleTriangle *obj = stack->object;
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dasstyleOutlinecolor != NULL && obj->dasstyleOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dasstyleLinewidth != NULL && obj->dasstyleLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "SPAN"))
    {
    struct dasstyleSpan *obj = stack->object;
    if (obj->dasstyleColor != NULL && obj->dasstyleColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dasstyleWidth != NULL && obj->dasstyleWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    }
else if (sameString(name, "WIDTH"))
    {
    struct dasstyleWidth *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "COLOR"))
    {
    struct dasstyleColor *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "OUTLINECOLOR"))
    {
    struct dasstyleOutlinecolor *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "LINEWIDTH"))
    {
    struct dasstyleLinewidth *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "PARALLEL"))
    {
    struct dasstyleParallel *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "NORTHEAST"))
    {
    struct dasstyleNortheast *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "SOUTHWEST"))
    {
    struct dasstyleSouthwest *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "FONT"))
    {
    struct dasstyleFont *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "FONTSIZE"))
    {
    struct dasstyleFontsize *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "STRING"))
    {
    struct dasstyleString *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "STYLE"))
    {
    struct dasstyleStyle *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

